// Installationsberwachung fr Windows 95/NT
// iwatchsu.cpp     Support Functions
// 1998 by c't / Matthias Withopf
// Gendert 06/03 h#s

#include "iwatchsu.h"

// Hilfsfunktionen

void MemSet(Pointer s,Byte b,unsigned int Size)
{
  PByte p = (PByte)s;
  while (Size-- > 0)
    *p++ = b;
}

void MemCpy(Pointer Dest,Pointer Src,unsigned int Size)
{
  PByte Src1 = (PByte)Src;
  PByte Dst1 = (PByte)Dest;
  while (Size-- > 0)
    *Dst1++ = *Src1++;
}
/*
void MemMove(Pointer Dest,Pointer Src,unsigned int Size)
{
  if (Dest < Src)
    MemCpy(Dest,Src,Size);
  else if (Dest > Src)
    {
      PByte Src1 = ((PByte)Src)  + Size - 1;
      PByte Dst1 = ((PByte)Dest) + Size - 1;
      while (Size-- > 0)
        *Dst1-- = *Src1--;
    }
}*/
/*
int vfprintf(HANDLE f, LPCTSTR format,va_list arg) {
 TCHAR buf[4096];
 return _lwrite((HFILE)f,buf,wvsprintf(buf,format,arg));
}

int _cdecl printf(LPCTSTR format,...) {
 vfprintf(GetStdHandle(STD_OUTPUT_HANDLE),format,(va_list)(&format+1));
}

int _cdecl fprintf(HANDLE f, LPCTSTR format,...) {
 vfprintf(f,format,(va_list)(&format+1));
}
*/
unsigned long strtoul(LPCTSTR s, LPTSTR* end, int base) {
 unsigned long a;
 unsigned b;

 while (*s==T(' ') || *s==T('\t')) s++;	// fhrender Weiraum
 for (a=0; ; s++) {			// MBCS kein Problem
  b=*s-T('0');
  if (b>9) {
   if (end) (*end)=(LPTSTR)s;
   return a;
  }
  a=a*base+b;
 }
}

Pointer _cdecl operator new(unsigned int Size) {
  if (!Size) ++Size;
  return LocalAlloc(LMEM_FIXED,Size);
}

void _cdecl operator delete(Pointer p) {
 LocalFree(p);
}

#if defined(__BORLANDC__)
Pointer _cdecl operator new[](unsigned int Size)
{
  return ::operator new(Size);
}

void _cdecl operator delete[](Pointer p)
{
  ::operator delete(p);
}
#endif

LPTSTR GetFileNamePtr(LPCTSTR s) {
// Liefert Zeiger auf Dateiname, hinter letztes Zeichen aus \/:
 LPCTSTR m;
st: 				// m = Kandidat fr Dateiname
 for(m=s;;s=CharNext(s)) switch (*s) {	// bei DBCS mehr vorrcken
  case T('\\'):
  case T('/'):
  case T(':'): s++; goto st;	// Einzelbyte, danach Anfang merken
  case 0: return (LPTSTR)m;
 }
}

LPTSTR GetFileNameExt(LPCTSTR s) {
// Liefert Zeiger auf Datei-Erweiterung, auf letzten, nicht-ersten Punkt
// oder, wenn nicht vorhanden, auf die terminierende Null
 LPTSTR m;

 s=GetFileNamePtr(s);
 while (*s==T('.')) s++;	// Fhrende Punkte (z.B. ".login") ignorieren
 for(m=NULL;;s=CharNext(s)) switch(*s) {
  case T('.'): m=(LPTSTR)s; break;	// Kandidat merken
  case 0: if (!m) m=(LPTSTR)s; return m;
 }
}

void InitStruct(LPVOID p, DWORD len) {
// Fllt eine Windows-typische Struktur mit Nullen und das erste
// DWORD mit der Struct-Gre
 MemSet(p,0,len);
 *(LPDWORD)p=len;
}
