// Installationsberwachung fr Windows 95/NT
// iwatchsu.cpp    Support Functions
// 1998 by c't / Matthias Withopf
// Gendert 06/03 h#s

#ifndef _IWATCHSU_H_
#define _IWATCHSU_H_

#if defined(_M_IX86)
  #define CPU_INTEL   1
#elif defined(_M_ALPHA)
  #define CPU_ALPHA   1
#endif

#define STRICT
#define WIN32_LEAN_AND_MEAN
#include <windows.h>

#define T(x) TEXT(x)
#define elemof(x) (sizeof(x)/sizeof((x)[0]))
#define nobreak

typedef                char Boolean;
#define Char TCHAR
#define Byte BYTE
typedef unsigned short   Word;
typedef unsigned long    LongWord;
typedef void *              Pointer;
typedef Boolean *           PBoolean;
#define Pchar LPSTR
#define PChar LPTSTR
typedef Byte *              PByte;
typedef Word *              PWord;
typedef LongWord *          PLongWord;

#define NULL   0
#define False  0
#define True   1

void MemSet(Pointer s,Byte b,unsigned int Size);
void MemCpy(Pointer Dest,Pointer Src,unsigned int Size);
void MemMove(Pointer Dest,Pointer Src,unsigned int Size);
#define StrLen(s)		lstrlen(s)
#define StrCpy(Dest,Src)	lstrcpy(Dest,Src)
#define StrCopy(Dest,Src,MaxLen) lstrcpyn(Dest,Src,MaxLen)
#define StrCat(Dest,Src)	lstrcat(Dest,Src)
#define StrCmp(s1,s2)		lstrcmp(s1,s2)
#define StrICmp(s1,s2)		lstrcmpi(s1,s2)
//int vfprintf(HANDLE f, LPCTSTR format,va_list arg);
//int _cdecl fprintf(HANDLE f, LPCTSTR format,...);
//int _cdecl printf(LPCTSTR format,...);
LPTSTR GetFileNamePtr(LPCTSTR s);
LPTSTR GetFileNameExt(LPCTSTR s);
void InitStruct(LPVOID p, DWORD len);
unsigned long strtoul(LPCTSTR s, LPTSTR* end=NULL, int base=10);

#endif

